local addon, _ = ...
local addonName = "Breeze"
local BreezeDisabled = false

Breeze = CreateFrame('Frame')
Breeze:RegisterEvent("ADDON_LOADED")
SetCVar("lastGarrisonMissionTutorial", 8) -- Setting tutorials as Seen on all possible alts.

local function myDebug(text)
  --[===[@debug@
  print("|cff2476ffBreeze:|r " .. text)
  --@end-debug@]===]
end

local function BreezeTroughAnimation(self, ...)
  self.NextMissionButton:SetText(NEXT)
  self.Stage.EncountersFrame.FadeOut:Play()
  self.animIndex = GarrisonMissionComplete_FindAnimIndexFor(GarrisonMissionComplete_AnimRewards) - 1
  self.animTimeLeft = 0
  
  if ( C_Garrison.CanOpenMissionChest(self.currentMission.missionID) ) then
    myDebug("Mission Success!")
    self.BonusRewards.ChestModel:Hide()
    local bonusRewards = self.BonusRewards
    bonusRewards.waitForEvent = true
    bonusRewards.waitForTimer = true
    bonusRewards.success = false
    bonusRewards:RegisterEvent("GARRISON_MISSION_BONUS_ROLL_COMPLETE")
    C_Timer.After(0.1, GarrisonMissionComplete_OnRewardTimer)
    C_Garrison.MissionBonusRoll(GarrisonMissionFrame.MissionComplete.currentMission.missionID)
    PlaySound("UI_Garrison_CommandTable_ChestUnlock_Gold_Success")
    self.NextMissionButton:Disable()
  else
    self.NextMissionButton:SetText("FAILED!")
    myDebug("Mission Failed")
  end
end

function BreezeInit(self, event, arg1, ...)

  if event == "ADDON_LOADED" and (select(5, GetAddOnInfo("MasterPlan")) ~= "MISSING" or (not select(5, GetAddOnInfo("MasterPlan")) ~= "DISABLED")) then
    BreezeDisabled = true
  end

  if event == "ADDON_LOADED" and arg1 == "Blizzard_GarrisonUI" and not BreezeDisabled then
    
    GARRISON_ANIMATION_LENGTH = 0
    
    -- always enabling the button, auto-roll the reward
    GarrisonMissionFrame.MissionComplete.NextMissionButton.Disable = function() C_Garrison.MissionBonusRoll(GarrisonMissionFrame.MissionComplete.currentMission.missionID) end
    -- hook our skip-animation-function-thingie
    hooksecurefunc('GarrisonMissionComplete_OnMissionCompleteResponse', BreezeTroughAnimation)
    
  end
end

function SlashCmdList.BREEZE(arg)
  if arg == "turbo" then
    BREEZE_TURBO = not BREEZE_TURBO
    SELECTED_CHAT_FRAME:AddMessage("|cff33ff99Breeze|r: Turbo mode " .. (BREEZE_TURBO and "enabled" or "disabled"))
  else
    SELECTED_CHAT_FRAME:AddMessage("|cff33ff99Breeze Options|r: turbo (autoclicking to next mission, currently not available)")
  end
end

Breeze:SetScript("OnEvent", BreezeInit)
